/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef MPEG_VLCTABS_HH
#define MPEG_VLCTABS_HH

#include "output/bitbuffer.hh"

void WriteMacroblockAddressIncrement(BitBuffer&,int incr);
void WriteMacroblockModes(BitBuffer&,uint8 packedmodes,uint3 pictype,uint2 scalabilitytype);

/* y1y2y3y4cb1cr1 cb2cr2cb3cr3cb4cr4 */
void WriteCBP(BitBuffer& bs,uint8 cbp1,uint8 cbp_ext,uint2 chromaformat);

void WriteDCSizeLumi  (BitBuffer&,int size);
void WriteDCSizeChroma(BitBuffer&,int size);

void CodeRunValue(BitBuffer&,int run,int value, bool first, bool UseTabB15, bool GenerateMPEG1);
int  BitsForRunValue(int runlen,int value, bool UseTabB15, bool GenerateMPEG1);
void CodeMotionCode(BitBuffer&,int mvdiff,int f,int rsize);

#endif
