/********************************************************************************
    Copyright (C) 1998/1999 Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef VERSION_HH
#define VERSION_HH

#define PRG_NAME    "SAMPEG  "
#define PRG_VERSION "v0.6.4"
#define PRG_DATE    "24.Feb.99"

/*
  History:
  0.6.4 - Bugfix: GOP Header sind jetzt an richtiger Position und Bildnumerierung stimmt.
  0.6.3 - Durchsatz bei Single-Frame-Grabbing gesteigert. Cropping des Eingabebildes.
  0.6.2 - Echtzeit-Grabbing. Grabbing laeuft im eigenen Thread. Erlaubt nun echte MPEG-Codierung
          von Echtzeitsignalen. Mit dem decimation-factor kann die Bildrate ggf. reduziert werden.
          Bildgroesse kann nun per Option geaendert werden.
  0.6.1 - Direktes YCbCr grabben, effizientere V4L-Unterstuetzung durch Auslagern gemeinsamer
          open() und ioctl()s in den Konstruktor.
  0.6.0 - Video4Linux Unterstuetzung, Einzelbildaufnahme ueber IR-Sender.
 */

#endif
